PROGRAM_NAME='Messenger'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
MessengerTP1       = 10002:2:1
MessengerTP2       = 10003:2:1
MessengerTP3       = 10006:2:1
MessengerTP4       = 10014:2:1
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
CHAR  cSentMsg[70]
//EDIT FOR THE ACTUAL NUMBER OF MESSENGER PANELS DEFINED ABOVE
DEV MessengerPNLS[] = {MessengerTP1,MessengerTP2,MessengerTP3,MessengerTP4}
DEV MessengerPnlSend
DEV MessengerPnlRecv
INTEGER nPanelName
INTEGER nMessageAllowed 
PERSISTENT INTEGER nAutoShow[4]
PERSISTENT INTEGER nPlaySnd[4]
//EDIT FOR THE ACTUAL NUMBER OF MESSENGER PANELS DEFINED ABOVE
//DEFAULT IS 4 PANELS, MAX NAME LENGTH IS 8 CHARACTERS
PERSISTENT CHAR PanelNames[4][8]
CHAR MessengerPnlSendName[8]
CHAR MessengerPnlRecvName[8]
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
(***********************************************************)
(***********************************************************)    
DEFINE_START
nMessageAllowed = 1
(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT
DATA_EVENT[MessengerPNLS]
{
  ONLINE:
  {
    WAIT 100
    {
      SEND_COMMAND DATA.DEVICE,"'^TXT-201,0, '"
      SEND_COMMAND DATA.DEVICE,"'^TXT-202,0, '"
      SEND_COMMAND DATA.DEVICE,"'^TXT-208,0,Message...'"
      SEND_COMMAND DATA.DEVICE,"'^BOP-212,0,255'"
      SEND_COMMAND DATA.DEVICE,"'^BOP-213,0,255'"
      SEND_COMMAND DATA.DEVICE,"'^TXT-210,0,',PanelNames[1]"
      SEND_COMMAND DATA.DEVICE,"'^TXT-211,0,',PanelNames[2]"
      SEND_COMMAND DATA.DEVICE,"'^TXT-212,0,',PanelNames[3]"
      SEND_COMMAND DATA.DEVICE,"'^TXT-213,0,',PanelNames[4]"
      // enable new/reply and clear buttons
      SEND_COMMAND DATA.DEVICE,"'^ENA-203,1'" 
      SEND_COMMAND DATA.DEVICE,"'^BOP-203,0,255'" 
      SEND_COMMAND DATA.DEVICE,"'^ENA-204,1'" 
      SEND_COMMAND DATA.DEVICE,"'^BOP-204,0,255'"
      //update saved config settings for auto-show popup
      IF(nAutoShow[1]) 
        ON[MessengerPNLS[1],205]     
      IF(nAutoShow[2]) 
        ON[MessengerPNLS[2],205]     
      IF(nAutoShow[3]) 
        ON[MessengerPNLS[2],205]     
      IF(nAutoShow[4]) 
        ON[MessengerPNLS[2],205]     
      //update saved config settings for play sound
      IF(nPlaySnd[1]) 
        ON[MessengerPNLS[1],206]     
      IF(nPlaySnd[2]) 
        ON[MessengerPNLS[2],206]     
      IF(nPlaySnd[3]) 
        ON[MessengerPNLS[2],206]     
      IF(nPlaySnd[4]) 
        ON[MessengerPNLS[2],206]     
    }
  }
  STRING:
  {     
    IF(FIND_STRING(DATA.TEXT,'KEYB-',1))
    {
      REMOVE_STRING(DATA.TEXT,'KEYB-',1)
      IF(LENGTH_STRING(DATA.TEXT)) 
      {
        IF(FIND_STRING(DATA.TEXT,'ABORT',1))
        {
        }
        ELSE //text was sent
        {          
            STACK_VAR INTEGER nIdx
            nIdx = GET_LAST(MessengerPNLS)

            IF([DATA.DEVICE,210])
            { 
              MessengerPnlRecv = MessengerPNLS[1]              
              MessengerPnlRecvName = PanelNames[1]
            }
            IF([DATA.DEVICE,211])
            {
              MessengerPnlRecv = MessengerPNLS[2]
              MessengerPnlRecvName = PanelNames[2]  
            }
            IF([DATA.DEVICE,212])
            {
              MessengerPnlRecv = MessengerPNLS[3]
              MessengerPnlRecvName = PanelNames[3] 
            }
            IF([DATA.DEVICE,213])
            {
              MessengerPnlRecv = MessengerPNLS[4]
              MessengerPnlRecvName = PanelNames[4]  
            }
            IF(nPanelName > 0) //Naming a panel?
            {
              SWITCH(nPanelName)
			  {
                CASE 1:
                  SEND_COMMAND MessengerPNLS,"'^TXT-210,0,',DATA.TEXT"
                CASE 2:
			      SEND_COMMAND MessengerPNLS,"'^TXT-211,0,',DATA.TEXT"
                CASE 3:
			      SEND_COMMAND MessengerPNLS,"'^TXT-212,0,',DATA.TEXT"
                CASE 4:
                  SEND_COMMAND MessengerPNLS,"'^TXT-213,0,',DATA.TEXT"
              }
              PanelNames[nPanelName] = DATA.TEXT
              nPanelName = 0    
            }
            ELSE // this is a message
            { 
              SEND_COMMAND MessengerPnlRecv,"'^TXT-208,0,Conversation with: ',MessengerPnlSendName"
              SEND_COMMAND MessengerPnlRecv,"'^ENA-203,1'" 
              SEND_COMMAND MessengerPnlRecv,"'^BOP-203,0,255'"
              IF(LENGTH_STRING(cSentMsg)) //was there a previous msg?
              {
                  SEND_COMMAND DATA.DEVICE,"'^TXT-202,0,',cSentMsg"
                  SEND_COMMAND MessengerPnlRecv,"'^TXT-202,0,',cSentMsg"
              }
			  SEND_COMMAND DATA.DEVICE,"'^TXT-201,0,',MessengerPnlSendName,': ',DATA.TEXT"
			  SEND_COMMAND MessengerPnlRecv,"'^TXT-201,0,',MessengerPnlSendName,': ',DATA.TEXT"
			  SEND_COMMAND MessengerPnlRecv,"'^TXT-203,0,','Reply'"
			  cSentMsg = "MessengerPnlSendName,': ',DATA.TEXT"
			  nPanelName = 0	
			  OFF[DATA.DEVICE,200]
			  ON[MessengerPnlRecv,200]              
              SEND_COMMAND DATA.DEVICE,"'@PPN-MESSENGER'"
              IF([MessengerPnlRecv,205])
			    SEND_COMMAND MessengerPnlRecv,"'@PPN-MESSENGER'"
			  IF([MessengerPnlRecv,206])
			    SEND_COMMAND MessengerPnlRecv,"'@SOU-IM.wav'"
            }          
        }
      }
    }
  }
}
BUTTON_EVENT[MessengerPNLS,204]//clear
{
  PUSH:
  {    
    nMessageAllowed = 1
    MessengerPnlSend = 0:0:0
    MessengerPnlRecv = 0:0:0
    SEND_COMMAND MessengerPNLS,"'^TXT-201,0, '"
    SEND_COMMAND MessengerPNLS,"'^TXT-202,0, '"
    SEND_COMMAND MessengerPNLS,"'^TXT-203,0,','New'" 
    SEND_COMMAND MessengerPNLS,"'^TXT-208,0,Message...'"
    cSentMsg = ''
    // Clear selected panel, and message text
    OFF[MessengerPNLS,200]
    OFF[MessengerPNLS,210]
    OFF[MessengerPNLS,211]
    OFF[MessengerPNLS,212]
    OFF[MessengerPNLS,213]
    // enable new/reply and clear buttons
    SEND_COMMAND MessengerPNLS,"'^ENA-203,1'" 
    SEND_COMMAND MessengerPNLS,"'^BOP-203,0,255'" 
    SEND_COMMAND MessengerPNLS,"'^ENA-204,1'" 
    SEND_COMMAND MessengerPNLS,"'^BOP-204,0,255'" 
  }
}
BUTTON_EVENT[MessengerPNLS,200]//Messenger btn
{
  PUSH:
  { 
    STACK_VAR INTEGER nLength
    nLength = LENGTH_ARRAY(MessengerPNLS)    
    //if there is already a messenger session in progress send notice, and disable clear button
    IF(nMessageAllowed = 0)
    { 
      IF((MessengerPnlSend.NUMBER > 0) && (MessengerPnlRecv.NUMBER > 0))
      {
        // lock out panels from clear, and new msg if other panels are already conversing
        IF(![BUTTON.INPUT.DEVICE,210] && ![BUTTON.INPUT.DEVICE,211] && ![BUTTON.INPUT.DEVICE,212] && ![BUTTON.INPUT.DEVICE,213])
        {
          SEND_COMMAND BUTTON.INPUT.DEVICE,"'^TXT-201,0,MESSAGING IS CURRENTLY BEING USED IN ANOTHER LOCATION...'"
          SEND_COMMAND BUTTON.INPUT.DEVICE,"'^ENA-203,0'" 
          SEND_COMMAND BUTTON.INPUT.DEVICE,"'^BOP-203,0,100'"
          SEND_COMMAND BUTTON.INPUT.DEVICE,"'^ENA-204,0'" 
          SEND_COMMAND BUTTON.INPUT.DEVICE,"'^BOP-204,0,100'"
        }
      }
    }
    ELSE
    {
      SEND_COMMAND BUTTON.INPUT.DEVICE,"'^ENA-204,1'" 
      SEND_COMMAND BUTTON.INPUT.DEVICE,"'^BOP-204,0,255'"
    }
    // Hide unused panel select btns...there should be at least two...
    IF(LENGTH_ARRAY(MessengerPNLS) = 2) //hide panel 3 and 4 btn
    { 
      SEND_COMMAND MessengerPNLS,"'^BOP-212,0,0'"
      SEND_COMMAND MessengerPNLS,"'^BOP-213,0,0'"
    }
    IF(LENGTH_ARRAY(MessengerPNLS) = 3)//hide panel 4 btn
    {
      SEND_COMMAND MessengerPNLS,"'^BOP-213,0,0'"      
    }
  }
}
BUTTON_EVENT[MessengerPNLS,205]//msngr auto-show popup
{
  PUSH:
  { 
	STACK_VAR INTEGER nIdx
    nIdx = GET_LAST(MessengerPNLS)
    [BUTTON.INPUT] = ![BUTTON.INPUT]    
    
      SWITCH(nIdx)
      {
        CASE 1:
          nAutoShow[1] = [BUTTON.INPUT]
        CASE 2:
          nAutoShow[2] = [BUTTON.INPUT]
	    CASE 3:
		  nAutoShow[3] = [BUTTON.INPUT]
	    CASE 4:
          nAutoShow[4] = [BUTTON.INPUT]
      }
  }
}
BUTTON_EVENT[MessengerPNLS,206]//msngr play sound
{
  PUSH:
  { 
	STACK_VAR INTEGER nIdx
    nIdx = GET_LAST(MessengerPNLS)
    [BUTTON.INPUT] = ![BUTTON.INPUT]    
    
      SWITCH(nIdx)
      {
        CASE 1:
          nPlaySnd[1] = [BUTTON.INPUT]
        CASE 2:
          nPlaySnd[2] = [BUTTON.INPUT]
	    CASE 3:
		  nPlaySnd[3] = [BUTTON.INPUT]
	    CASE 4:
          nPlaySnd[4] = [BUTTON.INPUT]
      }    
  }
}
BUTTON_EVENT[MessengerPNLS,210]//pnl 1
BUTTON_EVENT[MessengerPNLS,211]//pnl 2
BUTTON_EVENT[MessengerPNLS,212]//pnl 3
BUTTON_EVENT[MessengerPNLS,213]//pnl 4
{
  PUSH:
  { 
    STACK_VAR INTEGER nIdx
    nIdx = GET_LAST(MessengerPNLS)    

    OFF[BUTTON.INPUT.DEVICE,210]
    OFF[BUTTON.INPUT.DEVICE,211]
    OFF[BUTTON.INPUT.DEVICE,212]
    OFF[BUTTON.INPUT.DEVICE,213]

    MessengerPnlSend = BUTTON.INPUT.DEVICE
    MessengerPnlRecv = MessengerPNLS[BUTTON.INPUT.CHANNEL - 209]
    
    ON[BUTTON.INPUT.DEVICE,BUTTON.INPUT.CHANNEL]
    // Auto select the calling panel on the receive panel
    DO_PUSH(MessengerPnlRecv,nIdx + 209)
    //only one message session allowed at a time
    nMessageAllowed = 0
  }
}
BUTTON_EVENT[MessengerPNLS,207]//pnl name
{
  PUSH:
  { 
    STACK_VAR INTEGER nIdx
    nIdx = GET_LAST(MessengerPNLS)    
    nPanelName = nIdx    
  }
}
BUTTON_EVENT[MessengerPNLS,203]//new/reply
{
  PUSH:
  { 
    STACK_VAR INTEGER nIdx
    STACK_VAR INTEGER nPnl
    
    nIdx = GET_LAST(MessengerPNLS)    
    nPnl = 209 + nIdx
    MessengerPnlSendName = PanelNames[nIdx]
    //disable btn for selecting current panel
    SEND_COMMAND MessengerPNLS[nIdx],"'^ENA-',ITOA(nPnl),',0'" 
    SEND_COMMAND MessengerPNLS[nIdx],"'^BOP-',ITOA(nPnl),',0,100'"
    IF([MessengerPNLS[nIdx],210])
    {
      SEND_COMMAND MessengerPNLS[1],"'^TXT-208,0,',MessengerPnlSendName,': is typing'"
      SEND_COMMAND MessengerPNLS[1],"'^ENA-203,0'" 
      SEND_COMMAND MessengerPNLS[1],"'^BOP-203,0,100'"
    }
    IF([MessengerPNLS[nIdx],211])
    {
      SEND_COMMAND MessengerPNLS[2],"'^TXT-208,0,',MessengerPnlSendName,': is typing'"
      SEND_COMMAND MessengerPNLS[2],"'^ENA-203,0'" 
      SEND_COMMAND MessengerPNLS[2],"'^BOP-203,0,100'"
    }
    IF([MessengerPNLS[nIdx],212])
    {
      SEND_COMMAND MessengerPNLS[3],"'^TXT-208,0,',MessengerPnlSendName,': is typing'"
      SEND_COMMAND MessengerPNLS[3],"'^ENA-203,0'" 
      SEND_COMMAND MessengerPNLS[3],"'^BOP-203,0,100'" 
    }
    IF([MessengerPNLS[nIdx],213])
    {
      SEND_COMMAND MessengerPNLS[4],"'^TXT-208,0,',MessengerPnlSendName,': is typing'"
      SEND_COMMAND MessengerPNLS[4],"'^ENA-203,0'" 
      SEND_COMMAND MessengerPNLS[4],"'^BOP-203,0,100'"
    }    
  }
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

